#
# This is a miniweb server with a search engine.
# I have modify the minihttpd of the tclhttpd2.3.7 package of scriptics
# Look at the readme for more detais
# charles vidal
# vidalc@linux-france.org
#
# Simple Sample httpd/1.0 server in 250 lines of Tcl
# Stephen Uhler / Brent Welch (c) 1996 Sun Microsystems
# See the file "license.terms" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.

# This is a working sample httpd server written entirely in TCL with the
# CGI and imagemap capability removed.  It has been tested on the Mac, PC
# and Unix.  It is intended as sample of how to write internet servers in
# Tcl. This sample server was derived from a full-featured httpd server,
# also written entirely in Tcl.
# Comments or questions welcome (stephen.uhler@sun.com)

# Httpd is a global array containing the global server state
#  root:	the root of the document directory
#  port:	The port this server is serving
#  listen:	the main listening socket id
#  accepts:	a count of accepted connections so far

# HTTP/1.0 error codes (the ones we use)

# ProcCGIInput.tcl by Frank Pilhofer fp@informatik.uni-frankfurt.de
# Process CGI Input data in Tcl. Handle all means of possible input to
# a CGI script (POST, GET, URL-encoding) and output everything into the
# form() array.
#
# Source this file!
#

# List off directory and index

set INDEXOFINDEX "./indexing.txt"
set MAININDEX "./result.txt"


proc ProcCGIInput { query_string } {
    global env form argv

    if { [catch {set env(REQUEST_METHOD)}] } {set env(REQUEST_METHOD) ""}
    if { [catch {set env(QUERY_STRING)}] }   {set env(QUERY_STRING) $query_string}
    if { [catch {set env(PATH_INFO)}] }      {set env(PATH_INFO) ""}

# Don't work with 98
#    if { $env(REQUEST_METHOD) == "POST" } {
#	set _F_QueryString "[read stdin $env(CONTENT_LENGTH)]&"
#    } else {
#	set _F_QueryString "$env(QUERY_STRING)&"
#	}
    set _F_QueryString $query_string
    foreach _F_par $argv {
	append _F_QueryString "$_F_par&"
    }
#    foreach _F_par [split $env(PATH_INFO) "/"] {
#	append _F_QueryString "$_F_par&"
#    }
    #
    # process data
    #
    foreach _F_par [split $_F_QueryString "&"] {
	set _F_data [split $_F_par "="]
	set _F_var  [lindex $_F_data 0]
	set _F_val  [join [lrange $_F_data 1 end] "="]
	
	if { $_F_var == "" } {
	    continue
	}
	#
	# replace + by spaces
	#
	regsub -all {\+} $_F_val " " _F_val
	#
	# replace %XX by ascii character
	#
	while {[regexp -nocase {%([0-9a-f][0-9a-f])} $_F_val matsch hex]} {
	    set oct [eval format "%03o" 0x$hex]
	    eval regsub $matsch $_F_val "\\$oct" _F_val
	}
	#
	# okay
	#
	set form($_F_var) $_F_val
    }
}

#
# Loading the indexing of the ascii database of index
#
proc loadindexingfile { filename } {
global indexing
set f [open $filename r ]
while { ![eof $f] } {
        set string2eval [ gets $f ]
        if { $string2eval == "" } break
        regsub { } $string2eval ") " string2eval
        set string2eval "set indexing($string2eval"
        eval "$string2eval"
        }
}

proc loadlistefile { filename } {
global listfile
global tabofurl
global taboftitle
#lappend listfile "ERREUR "
set f [open $filename r ]
set nbfile [ gets $f ]
regsub {\[} $nbfile "set  " nbfile
regsub {\]} $nbfile " " nbfile
regsub "\:" $nbfile " " nbfile
eval $nbfile

for { set i 0 } { $i < $files } { incr i } {
        set string2eval [ gets $f ]
        if ([regexp -nocase {^([0-9]+)=} $string2eval match numentry]==0) {
			puts "not found num $string2eval " 
	}
        #if { $string2eval == "" } break
        #lappend listfile [list $string2eval]
	set indexv [string first "," $string2eval]
	if ($indexv==-1) {
			puts "error no , found in $stringeval "
			 continue }
	set url [string range  $string2eval [expr 1 + [ string length $numentry ] ] [ expr $indexv - 1 ]]
	set title [string range  $string2eval [ expr $indexv + 1] [ string length $string2eval ] ]
        set taboftitle($numentry) "$title"
        set tabofurl($numentry) "$url"
        }
}


proc sorttwoelement { a b }  {
set fa [lindex $a 0]
set fb [lindex $b 0]
if { $fa > $fb } { return 0 } else { return 1 }
}


#
# Fonction regardant si tout les mot de a sont dans b
#
proc getallword { a b } {
global form
	foreach word $a {
		if (![info exists form(ignorecase)]) {
			if {[lsearch $b $word ] == -1 } {
			 return -1
			}
		} else {
			if {[lsearch -regexp $b "$word" ] == -1 } {
			 return -1
			}
		}
	}
	return 0
}

proc search { sock arg } {
global INDEXOFINDEX
global form
global indexing
#global arrayresult
global listfile
global tablesite

global tabofurl
global taboftitle

global MAININDEX

#
# Pour tous les mots a rechercher, on les place dans le tableau tabword
#
foreach onearg $arg {
	set f [open "$MAININDEX" r ]
	set twoletter   [ string range $onearg 0 1 ]
	if (![info exists indexing($twoletter)]) {
        	puts $sock "No matches found"
        	puts $sock "Erreur $twoletter not found in the indexing file $INDEXOFINDEX "
		return
		}
	seek $f $indexing($twoletter)
	while { 1 } {
		 set wordline [ gets $f ]
		 if { $twoletter !=  [ string range $wordline 0 1 ] } {
					break
					}
		if (![info exists form(ignorecase)]) {
			regexp {([a-z0-9_]+)=>} $wordline all word reste
		 	if { [string compare $onearg  $word] == 0 } {
				regsub "=>"  "$wordline" "\) \{ \{" wordline
		 		regsub -all ":" "$wordline" "\} \{" wordline
		 		regsub -all "," "$wordline" " " wordline
		 		set wordline "set tabword\($wordline\} \}" 
		 		eval $wordline
			}
		} else {
			if { [ string first $onearg $wordline] != -1 } {
		 		regsub "=>"  "$wordline" "\) \{ \{" wordline
		 		regsub -all ":" "$wordline" "\} \{" wordline
		 		regsub -all "," "$wordline" " " wordline
		 		set wordline "set tabword\($wordline\} \}" 
		 		eval $wordline
			}
			}
	}
	close $f
}

#
# Pour tous les mots trouves dans l'index
# ont les place dans arrayresult
#

foreach  i [array names tabword] {
	foreach a $tabword($i) {
			if {  [ info exist arrayresult([lindex $a 0]) ] }  {
				set listtempo  [lrange $arrayresult([lindex $a 0]) 1 end] 
				lappend listtempo $i
				set arrayresult([lindex $a 0]) \
				"[ expr [lindex $arrayresult([lindex $a 0]) 0] + [lindex $a 1] ]  $listtempo "
			} else  { set arrayresult([lindex $a 0])  "[lindex $a 1] $i" 
				}
		}
	}

foreach i [ array names arrayresult ] {
	lappend listresult "[lindex $arrayresult($i) 0] $i [lrange $arrayresult($i) 1 end]"
}
if { ![ info exist listresult ] } {
        puts $sock "No matches found"
        } else {
  	puts $sock { <table width=100%% cellpadding=2 cellspacing=0 border=0>\
			<tr><td bgcolor=#3366cc align=left nowrap><font face=arial,sans-serif size=-1 color=white>nb Results <b>}
	puts $sock "[llength $listresult] </b>. </font></td></tr></table> "

	set listresult [ lsort  -command sorttwoelement $listresult  ]
	foreach i $listresult {
		if { [ getallword "$arg"  "[lrange $i 2 end]" ] == 0 } {
			puts $sock "<blockquote>"
			set the_title "$taboftitle([ lindex $i 1])"
			puts $sock "<br><A HREF=\"$tabofurl([lindex $i 1])\">$the_title </a><br>[lrange $i 2 end] nbhit [lindex $i 0]"
			puts $sock "<br>$tabofurl([lindex $i 1])"
			puts $sock "</blockquote>"
			}
		}
	}
 parray form
}

proc searchcgi { sock } {
global form
global tablesite
  puts $sock ""
  puts $sock { <html> <head><META HTTP-EQUIV="content-type" CONTENT="text/html; charset=ISO-8859-1"> }
  puts $sock "<title>Doli Search: $form(name) </title> </head>"
  puts $sock {<body bgcolor=#ffffff text=#000000 link=#0000cc vlink=#551A8B alink=#ff0000>}
  puts $sock { <img src="doli.jpg" alt="doli img"><br> }
  puts $sock { <a href="/index.html"> Faire une nouvelle recherche </a> }
  set form(name) [ string tolower $form(name) ]
  search $sock  $form(name) 

  puts $sock "</body>"
  puts $sock "</html>"
}

array set HttpdErrors {
    204 {No Content}
    400 {Bad Request}
    404 {Not Found}
    503 {Service Unavailable}
    504 {Service Temporarily Unavailable}
    }

array set Httpd {
    bufsize	32768
    sockblock	0
}

# Start the server by listening for connections on the desired port.

proc Httpd_Server {root {port 80} {default index.html}} {
    global Httpd

    array set Httpd [list root $root default $default]
    if {![info exists Httpd(port)]} {
	set Httpd(port) $port
	set Httpd(listen) [socket -server HttpdAccept $port]
	set Httpd(accepts) 0
    }
    return $Httpd(port)
}

# Accept a new connection from the server and set up a handler
# to read the request from the client.

proc HttpdAccept {newsock ipaddr port} {
    global Httpd
    upvar #0 Httpd$newsock data

    incr Httpd(accepts)
    fconfigure $newsock -blocking $Httpd(sockblock) \
	-buffersize $Httpd(bufsize) \
	-translation {auto crlf}
#    HHttpd_Log $newsock Connect $ipaddr $port
    set data(ipaddr) $ipaddr
    fileevent $newsock readable [list HttpdRead $newsock]
}

# read data from a client request

proc HttpdRead { sock } {
    upvar #0 Httpd$sock data

    set readCount [gets $sock line]
    if {![info exists data(state)]} {
	if [regexp {(POST|GET) ([^?]+)\??([^ ]*) HTTP/1.([1|0])} \
		$line x data(proto) data(url) data(query)] {
    	puts "x $x proto $data(proto) url $data(url) query $data(query)"
	    set data(state) mime
	    Httpd_Log $sock Query $line
	} else {
	    HttpdError $sock 400
	    Httpd_Log $sock Error "bad first line:$line"
	    HttpdSockDone $sock
	    return
		}
    }

    # string compare $readCount 0 maps -1 to -1, 0 to 0, and > 0 to 1

    set state [string compare $readCount 0],$data(state),$data(proto)
    switch -- $state {
	0,mime,GET	-
	0,query,POST	{ HttpdRespond $sock }
	0,mime,POST	{ set data(state) query }
	1,mime,POST	-
	1,mime,GET	{
	    if [regexp {([^:]+):[ 	]*(.*)}  $line dummy key value] {
		set data(mime,[string tolower $key]) $value
	    }
	}
	1,query,POST	{
	    set data(query) $line
	    HttpdRespond $sock
	}
	default {
	    if [eof $sock] {
		Httpd_Log $sock Error "unexpected eof on <$data(url)> request"
	    } else {
		Httpd_Log $sock Error "unhandled state <$state> fetching <$data(url)>"
	    }
	    HttpdError $sock 404
	    HttpdSockDone $sock
	}
    }
}

# Close a socket.
# We'll use this to implement keep-alives some day.

proc HttpdSockDone { sock } {
    upvar #0 Httpd$sock data
    unset data
    close $sock
}

# Respond to the query.

proc HttpdRespond { sock } {
    global Httpd
    global env
    upvar #0 Httpd$sock data

    set mypath [HttpdUrl2File $Httpd(root) $data(url)]
    if {[string first "searchtcl.html" $mypath] !=-1} {
	ProcCGIInput $data(query)
	searchcgi $sock
	HttpdSockDone $sock
	return
	} 
    if {[string length $mypath] == 0} {
	HttpdError $sock 400
	Httpd_Log $sock Error "$data(url) invalid path"
	HttpdSockDone $sock
	return
    }

    if {![catch {open $mypath} in]} {
	puts "HTTP/1.0 200 Data follows"
	puts $sock "HTTP/1.0 200 Data follows"
	puts $sock "Date: [HttpdDate [clock clicks]]"
	puts $sock "Last-Modified: [HttpdDate [file mtime $mypath]]"
	puts $sock "Content-Type: [HttpdContentType $mypath]"
	puts $sock "Content-Length: [file size $mypath]"
	puts $sock ""
	fconfigure $sock -translation binary -blocking $Httpd(sockblock)
	fconfigure $in -translation binary -blocking 1
	flush $sock
#	copychannel $in $sock $Httpd(bufsize)
#	copychannel $in $sock
	fcopy  $in $sock
	HttpdSockDone $sock
#	fileevent $sock writable [list HttpdCopy $in $sock $mypath]
    } else {
	puts "HttpError 404 "
	HttpdError $sock 404
	Httpd_Log $sock Error "$data(url) $in"
	HttpdSockDone $sock
    }
}
proc HttpdCopy {in sock mypath} {
    global Httpd
    copychannel $in $sock $Httpd(bufsize)
    if [eof $in] {
	close $in
	HttpdSockDone $sock
	Httpd_Log $sock Done "$mypath"
    }
}

# convert the file suffix into a mime type
# add your own types as needed

array set HttpdMimeType {
    {}		text/plain
    .txt	text/plain
    .htm	text/html
    .html	text/html
    .gif	image/gif
    .jpg	image/jpeg
    .xbm	image/x-xbitmap
}

proc HttpdContentType {path} {
    global HttpdMimeType

    set type text/plain
    catch {set type $HttpdMimeType([file extension $path])}
    return $type
}

# Generic error response.

set HttpdErrorFormat {
    <title>Error: %1$s</title>
    Got the error: <b>%2$s</b><br>
    while trying to obtain <b>%3$s</b>
}

proc HttpdError {sock code} {
    upvar #0 Httpd$sock data
    global HttpdErrors HttpdErrorFormat

    append data(url) ""
    set message [format $HttpdErrorFormat $code $HttpdErrors($code)  $data(url)]
    puts $sock "HTTP/1.0 $code $HttpdErrors($code)"
    puts $sock "Date: [HttpdDate [clock clicks]]"
    puts $sock "Content-Length: [string length $message]"
    puts $sock ""
    puts $sock $message
}

# Generate a date string in HTTP format.

proc HttpdDate {clicks} {
    return [clock format $clicks -format {%a, %d %b %Y %T %Z}]
}

# Log an Httpd transaction.
# This should be replaced as needed.

proc Httpd_Log {sock reason args} {
    global httpdLog httpClicks
    if {[info exists httpdLog]} {
	if ![info exists httpClicks] {
	    set last 0
	} else {
	    set last $httpClicks
	}
	set httpClicks [clock clicks]
	puts $httpdLog "[clock format [clock seconds]] ([expr $httpClicks - $last])\t$sock\t$reason\t[join $args { }]"
    }
}

# Convert a url into a pathname.
# This is probably not right.

proc HttpdUrl2File {root url} {
    global HttpdUrlCache Httpd

    if {![info exists HttpdUrlCache($url)]} {
	puts " HttpdUrlCache($url) n'existe pas "
    	lappend pathlist $root
    	set level 0
	foreach part  [split $url /] {
	    set part [HttpdCgiMap $part]
	    if [regexp {[:/]} $part] {
		return [set HttpdUrlCache($url) ""]
	    }
	    switch -- $part {
		.  { }
		.. {incr level -1}
		default {incr level}
	    }
	    if {$level <= 0} {
		return [set HttpdUrlCache($url) ""]
	    } 
	    lappend pathlist $part
	}
    	set file [eval file join $pathlist]
	if {[file isdirectory $file]} {
	    set file [file join $file index.html]
#	    set file [file join $file $Httpd(default)]
	}
    	set HttpdUrlCache($url) $file
    }
    return $HttpdUrlCache($url)
}

# Decode url-encoded strings.

proc HttpdCgiMap {data} {
    regsub -all {([][$\\])} $data {\\\1} data
    regsub -all {%([0-9a-fA-F][0-9a-fA-F])} $data  {[format %c 0x\1]} data
    return [subst $data]
}

proc bgerror {msg} {
    global errorInfo
    puts stderr "bgerror: $msg\n$errorInfo"
}


catch {rename unsupported0 copychannel}
switch $tcl_platform(platform) {
  unix {
	}
  windows {
	pack [ label .l -text "Browse the documentation at this adress http://localhost:8080/" ]
	pack [ button .b -text "Exit" -command "exit" ]
	# Merci a Pascal Bouvier <pascal@prologianet.univ-mrs.fr pour le lancement d'un explorateur
	exec $::env(COMSPEC) /c start http://localhost:8080 &
	}
}

loadindexingfile $INDEXOFINDEX
loadlistefile $MAININDEX

Httpd_Server . 8080 index.html
puts stderr "Starting Tcl httpd server on [info hostname] port 8080"

vwait forever		;# start the Tcl event loop
